#include<stdio.h>
#include"floppy.h"

typedef struct chunk {
	int start;	// start sector
	int end;	// end sector
	int size;	// size in sectors
} chunk_t;

int main() {
char tbuf[1024];
int cnt,c,s,i,j,tmap,sfree,start,end;
chunk_t freelist[1280];

	sector_read(0,0,0,1,tbuf);
/*
	for(i=0;i<1024;i+=16) {
		printf("%04x: ",i&0xffff);
		for(j=0;j<16;j++) 
			printf("%02x ",tbuf[i+j]&0xff);
		for(j=0;j<16;j++)
			if (tbuf[i+j]<0x20) printf("."); else printf("%c",tbuf[i+j]);
		printf("\n");
	}			
*/
	start=-1; cnt=0;
	for(c=0;c<80;c++) {
		tmap=((tbuf[0x80+(c<<1)]<<8) | tbuf[0x81+(c<<1)])&0xffff;
//		printf("%d: %04x\n",c*16,tmap&0xffff);
		for(s=0;s<16;s++) {
			sfree=(tmap&(1<<s))>>s;
			j=c*16+s;
//			printf("%d: %d\t%d\t%d\n",j,sfree,start,end);
			if ((sfree==0)&&(j<1279)) {
				if (start==-1) 
					start=j;
				else
					end=j;
			} else {
				if (start!=-1) {
					freelist[cnt].start=start;
					freelist[cnt].end=end;
					freelist[cnt].size=1+end-start;
					cnt++;
					start=-1;
				}
			}
		}
	}
	
	for(i=0;i<cnt;i++) {
		printf("Chunk %d:\n",i);
		printf("\tstart %d\n",freelist[i].start);
		printf("\tend   %d\n",freelist[i].end);
		printf("\tsize  %dkByte\n",freelist[i].size);
		printf("\n");
	}

	exit(0);
}